#include<stdio.h>
#include <string.h> 
#include <math.h> 
#include <stdlib.h>

#include <iostream>
#include <fstream>
#include <values.h>
#include <math.h>
#include <sstream>
#include <time.h>
#define float double
using namespace std;

#define   length       31
#define   c            0.05
#define   E            0.1
#define   plasma       5.34505           
#define   pi           3.141592654
#define   cutoff       7
#define   Iconf        25
#define   Zeitmax      10000
#define   parmax       10000
#define   nphase       40
#define   neout        100
#define   thermtime    3000



#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];
#define outfile_x "Strom_3D_Lochdynamik-Coloumb_WW_X0.0__%f_%f_%d"
/************************/
double      pot[length][length][length],energy[length][length][length];
int         npar,x_par[parmax],y_par[parmax],z_par[parmax],lat[length][length][length],volume;
int         dirx[6]={-1,1,0,0,0,0},diry[6]={0,0,-1,1,0,0},dirz[6]={0,0,0,0,-1,1};
double      totenergy,deltaenergy,thermenergy[neout];
int         ieout,ranx,rany,ranz,ipar,totsteps, iestep, esteps,iconf,i,j,k,hpar,hlen,thermsteps;
double      norm,ion_sphere_radius,beta,energy_correction,mu;
int         iz=1, mz[250],jzmax=2147483647,jz,l;
double      current[Iconf][nphase+1],curfct[nphase+1],f;



const long seed=372067;

int np[500000];
double rnd;


void       outputfile();
void       calpot(void);
void       thermalize(void);
void       metropolis_therm(int steps);
/************************/
void     thermalize(void)
{
double   therm_step_interv;
int      ieout, iesteps;
         therm_step_interv=round(thermsteps/neout);
         esteps=10;
         thermsteps= thermtime*npar;
         
thermenergy[0]=0.0; totenergy=0.0;

for (i=0;i<npar;i++) 
for (j=i;j<npar;j++){ 
thermenergy[0]=thermenergy[0]+pot[abs(x_par[i]-x_par[j])][abs(y_par[i]-y_par[j])][abs(z_par[i]-z_par[j])]
                             +energy[x_par[i]][y_par[i]][z_par[i]];
totenergy=thermenergy[0];
}

/*for (i=0;i<npar;i++) {
 thermenergy[0]=thermenergy[0]+energy[x_par[i]][y_par[i]][z_par[i]];
totenergy=thermenergy[0];
}*/
                  

                 for (ieout=1;ieout<=neout;ieout++){                  /*(*1*)*/
                 metropolis_therm(therm_step_interv-esteps);
                  thermenergy[ieout]=0.0;
                 for (iestep=1;iestep<=esteps;iestep++){ /*(*2*)*/
                 metropolis_therm(1);
                 thermenergy[ieout]=thermenergy[ieout]+totenergy
                                                        /*(*2*)*/;}
                  thermenergy[ieout]=thermenergy[ieout]/esteps;         /*(*1*)*/}


                 FILE * outfile_thermalization;
                 outfile_thermalization = fopen("therm_Coul_X0.0.dat", "w");
                 for (ieout=1;ieout<=neout;ieout++){
                 fprintf(outfile_thermalization, "%d  %f\n",ieout,thermenergy[ieout]);

                                                    }
                  fclose(outfile_thermalization);
/* end of thermalize */}
/*****************************************/

void rndNum(int seed)  
{
norm=1.0/jzmax;
int jz,jzmax=2147483647,a0=16807;
jz=2*seed+1;for(i=0;i < 250;i++){jz *= a0; if(jz < 0) jz += jzmax +1; mz[i] = jz;}
}
/*****************************************/
int main() 
{

srand (time(NULL));
/***********************************************/
volume=length*length*length;    
npar=int(c*volume);printf("npar ist %d\n",npar);   
ion_sphere_radius=pow(3.0/(4.0*pi*c),1/3.0);
beta=plasma*ion_sphere_radius;printf("beta ist %f\n",beta);
mu= 0.693474;

for(i = 0;i<(length);i++){  
for(j = 0;j<(length);j++){                                                                                
for(k = 0;k<(length);k++){
lat[i][j][k]=1;}}}
/***********************************************/
calpot();
/***********************************************/

double*params=new double [(length)*(length)*(length)];
ifstream input;
input.open("Platzenergie_X_0.0.dat");
for(i = 0;i<((length)*(length)*(length));i++){
input>>params[i];}
input.close();
for(i = 0;i<(length);i++)  
for(j = 0;j<(length);j++)                                                                                
for(k = 0;k<(length);k++){
energy[i][j][k]=-1*params[length*length*i+length*j+k];}

/***********************************************/
ipar=0;
while(ipar<npar){

ranx = rand() % (length); rany = rand() % (length); ranz = rand() % (length);

if(lat[ranx][rany][ranz]==1){
Kirkpatrick;rnd = mz[iz]*norm;
if(rnd<(double)(1/(exp((energy[ranx][rany][ranz]-mu)*beta)+1))){
x_par[ipar]=ranx; y_par[ipar]=rany; z_par[ipar]=ranz;
lat[ranx][rany][ranz]=0;

ipar++;}}}
printf("Die Anzahl der Teilchen: %d\n",npar);
/***********************************************/
thermalize();

for(iconf=1;iconf<=Iconf;++iconf){
printf("iconf=%d\t\n",iconf);
rndNum(seed);
for(i=0;i<500000; i++){np[i]=0;}
/************************************************************************/
hpar=jzmax/npar+1; 
const int hdir=jzmax/6+1;
double transprob,time,phtime[nphase+1],deltasteps[nphase+1];
long xback,xfor;
int cur,ranpar,randir,deltax,newx,newy,newz,oldx,oldy,oldz,istep,iphase;
phtime[0]=0.0;
for(i=1;i<=nphase;i++){
phtime[i]=Zeitmax*i/(nphase);
deltasteps[i]=npar*(phtime[i]-phtime[i-1]);
//printf("%f\n",deltasteps[i]);
}
for(i=1;i<=nphase;i++) current[iconf][i]=0.0;

for(i=1;i<=nphase;i++){/*2*/
cur=0;
for(j=0;j<deltasteps[i];j++){/*3*/
time=phtime[i-1]+(double) j/npar;
Kirkpatrick;ranpar=mz[iz]/hpar;
f=E*beta; 
xback=jzmax*(1.0-f)/6.0;
xfor=jzmax*(1.0+f)/6.0;
Kirkpatrick;
if(mz[iz]<=xback) randir=0;
else if(mz[iz]<=xfor) randir=1;
else randir=mz[iz]/hdir;
/********************************************/
deltax=dirx[randir];
newx=x_par[ranpar]+dirx[randir];
newy=y_par[ranpar]+diry[randir];
newz=z_par[ranpar]+dirz[randir];
if(newx==length) newx=0;
else if(newx==-1) newx=length-1;
else if((newx<length-1)&(newx>0)) newx=x_par[ranpar]+dirx[randir];
if(newy==length) newy=0;
else if(newy==-1) newy=length-1;
else if((newy<length-1)&(newy>0)) newy=y_par[ranpar]+diry[randir];
if(newz==length) newz=0;
else if(newz==-1) newz=length-1;
else if((newz<length-1)&(newz>0)) newz=z_par[ranpar]+dirz[randir];

if((lat[newx][newy][newz]==1)){/*4*/
oldx=x_par[ranpar];oldy=y_par[ranpar];oldz=z_par[ranpar];

deltaenergy=0.0;
for(l=0;l<npar;l++)
deltaenergy=deltaenergy+pot[abs(x_par[l]-newx)][abs(y_par[l]-newy)][abs(z_par[l]-newz)]
                       
                       -pot[abs(x_par[l]-oldx)][abs(y_par[l]-oldy)][abs(z_par[l]-oldz)]
                       
                       +energy[newx][newy][newz]
                       
                       -energy[x_par[l]][y_par[l]][z_par[l]];
deltaenergy=deltaenergy+energy_correction;

if(deltaenergy<=0.0){/*5a*/
cur+=deltax;//printf("cur ist %d\n",cur);
x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;/*5a*/
}
else{/*5b*/
Kirkpatrick;
transprob=jzmax*exp(-beta*deltaenergy);
if(mz[iz]<=transprob){/*6b*/
cur+=deltax;
x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;
/*6b,5b*/}}


/*4*/}


current[iconf][i]=current[iconf][i]+cur;//printf("current ist %f\n",current[iconf][i]);
/*3*/}
/*2*/}

for(iphase=1;iphase<=nphase;iphase++){
current[iconf][iphase]=current[iconf][iphase]/(double)((volume)*(phtime[iphase]-phtime[iphase-1]));//printf("current ist %f\n",current[iconf][iphase]);
}
/*****************************************/  
}



for(i=1;i<=nphase;i++){
for(iconf=1;iconf<=Iconf;++iconf){
curfct[i]+=current[iconf][i]/Iconf;}
//printf(" %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
outputfile() ;        
        
return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void metropolis_therm(int steps)
{
int newx,newy,newz,oldx,oldy,oldz;
int ranpar,randir,ipar,random;
int iestep, esteps=10;
double transprob;


for (iestep=1;iestep<=steps;iestep++){

ranpar=rand() % (npar);//printf("ranpar ist %d\n",ranpar);
randir=rand() % 6;   //printf("randir ist %d\n",randir);

newx=x_par[ranpar]+dirx[randir];
newy=y_par[ranpar]+diry[randir];
newz=z_par[ranpar]+dirz[randir];

if(newx==length)                  newx=0;
else if(newx==-1)                 newx=length-1;
else if((newx<=length-1)&(newx>=0)) newx=x_par[ranpar]+dirx[randir];

if(newy==length)                  newy=0;
else if(newy==-1)                 newy=length-1;
else if((newy<=length-1)&(newy>=0)) newy=y_par[ranpar]+diry[randir];

if(newz==length)                  newz=0;
else if(newz==-1)                 newz=length-1;
else if((newz<=length-1)&(newz>=0)) newz=z_par[ranpar]+dirz[randir];


//printf("Das ausgewaehlte %d-te Teilchen kann zum [%d][%d][%d] \n",ranpar,newx,newy,newz);
if((lat[newx][newy][newz]==1)){/*4*/

oldx=x_par[ranpar];oldy=y_par[ranpar];oldz=z_par[ranpar];


deltaenergy=0.0;
for(l=0;l<npar;l++)
deltaenergy=deltaenergy+pot[abs(x_par[l]-newx)][abs(y_par[l]-newy)][abs(z_par[l]-newz)]
                       
                       -pot[abs(x_par[l]-oldx)][abs(y_par[l]-oldy)][abs(z_par[l]-oldz)]
                       
                       +energy[newx][newy][newz]
                       
                       -energy[x_par[l]][y_par[l]][z_par[l]];
deltaenergy=deltaenergy+energy_correction;
//deltaenergy=energy[newx][newy][newz]-energy[oldx][oldy][oldz];


               

           if(deltaenergy<=0){/*5a*/
           totenergy=totenergy+deltaenergy;
           x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
           lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;/*5a*/
                           }

else{/*5b*/
Kirkpatrick;
transprob=jzmax*exp(-beta*deltaenergy);
if(mz[iz]<=transprob){/*6b*/
x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;
/*6b,5b*/}}
          /*4*/}
}


}
//(******************************************************************************)
void   calpot(void){

int    lquad=length*length;
double gpara=pi/length,kconst=2*pi/length,
       aconst=pi*pi/(lquad*gpara*gpara),
       bconst=1/(pi*length),
       cconst=pi/(lquad*length*gpara*gpara),
       dconst=2*gpara/sqrt(pi);

int    dx,dy,dz;
double pota,potb,erfc,argerfc,distance,f,f1,f2,f3;
int    n1,n2,n3;
int    dquad,nquad,distquad;
       
for(dx=0;dx<length;++dx)
for(dy=0;dy<length;++dy)
for(dz=0;dz<length;++dz){/*1*/
dquad=dx*dx+dy*dy+dz*dz;
pota=0.0; potb=0.0;
for(n1=cutoff;n1>-1;--n1){/*2a*/   
f1=2*cos(kconst*n1*dx);
if(n1=0){f1=f1-1;}
for(n2=cutoff;n2>-1;--n2){/*3a*/        
f2=2*cos(kconst*n2*dy);
if(n2=0){ f2=f2-1;}
for(n3=cutoff;n3>0;--n3){/*4a*/  
f3=2*cos(kconst*n3*dz);
if(n3=0){ f3=f3-1;}
nquad=n1*n1+n2*n2+n3*n3;
if (nquad!=0){
pota=pota+f1*f2*f3*exp(-aconst*nquad)/nquad;}
}/*4a*/
}/*3a*/
}/*2a*/                            
pota=bconst*pota;
for(n1=-cutoff;n1<cutoff+1;++n1)
for(n2=-cutoff;n2<cutoff+1;++n2)
for(n3=-cutoff;n3<cutoff+1;++n3){ /*2b*/
nquad=n1*n1+n2*n2+n3*n3;
distquad=dquad+nquad*lquad-2*length*(n1*dx+n2*dy+n3*dz);
distance=sqrt(distquad);
argerfc=gpara*distance;
if ((nquad+distquad)!=0){ /*3b*/
f=1/(1+0.32759*argerfc);
erfc=f*(0.25482+f*(-0.28449+f*(1.42141+f*(-1.45315+f*1.06140))))*
                  exp(-(argerfc*argerfc));
potb=potb+erfc/distance;
}/*3b*/
}/*2b**/
pot[dx][dy][dz]=pota+potb-cconst;
                          
}/*1*/
pot[0][0][0]=pot[0][0][0]-dconst;

FILE * outfile_potcalc;
outfile_potcalc = fopen("pot_31.dat", "w");
for(dx=0;dx<length;++dx)
for(dy=0;dy<length;++dy)
for(dz=0;dz<length;++dz){ 
fprintf(outfile_potcalc, "%d %d %d  %f\n",dx,dy,dz,pot[dx][dy][dz]);
//printf("pot[%d][%d][%d] %f\n",dx,dy,dz,pot[dx][dy][dz]);
}
energy_correction=pot[0][0][0]-pot[0][0][1];
fclose(outfile_potcalc);
/* end of calpot */}
/******************************************/
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x,c,beta,length);	
strcat(name_x, ".dat");// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");
for(i=1;i<12;i++){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
l=15;
for(i=12;i < nphase; i++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);

if(i==t){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
l++;}}
fclose(outfile);
}
/******************************************/

