#include<stdio.h>
#include <string.h> 
#include <math.h>




#define nlin 20
#define c   0.1      
#define beta 5
#define Zeitmax 10000
#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];
#define outfile_x "Cross_Correlation_3D_1_%f_%d"
/************************/
int iz=1;
int mz[250];
const long seed=372067;
int jzmax=2147483647,jz,a0=16807;
int np[500000];
double norm,rnd,mu;
/************************/
double energy[nlin][nlin][nlin];
int    lat[nlin][nlin][nlin],lat1[nlin][nlin][nlin]
       ,distX[nlin*nlin*nlin],distY[nlin*nlin*nlin],distZ[nlin*nlin*nlin];
int    i,j,k,hpar,npar,x[nlin*nlin*nlin],y[nlin*nlin*nlin],z[nlin*nlin*nlin];
int    dirx[6]={-1,1,0,0,0,0};
int    diry[6]={0,0,-1,1,0,0};
int    dirz[6]={0,0,0,0,-1,1};

/************************/
int jump,ZeitM, ZeitInt;
double Zeit,R[Zeitmax][nlin*nlin*nlin],Kreuzkorr[Zeitmax];
/************************/
void outputfile();
void rndNum(int seed);
void MDS_determination(void);
void initialize();
void readstruc ();
/************************/
void rndNum(int seed)  
{
norm=1.0/jzmax;
int jz,jzmax=2147483647,a0=16807;
jz=2*seed+1;for(i=0;i < 250;i++){jz *= a0; if(jz < 0) jz += jzmax +1; mz[i] = jz;}
}
/************************/
int main() 
{
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
initialize ();
readstruc();
MDS_determination();
outputfile();
}
/************************/
void initialize () 
{
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
Kirkpatrick;rnd = mz[iz]*norm;
energy[i][j][k]=rnd;
}}}
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
lat[i][j][k]=0;lat1[i][j][k]=0;}}}
}
/************************/
void readstruc ()  
{
mu=(1/(double)beta)*log((1-exp(-c*beta))/(exp(-1*c*beta)-exp(-1*beta)));
printf(" mu ist %f\n",mu);
npar=0;
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
Kirkpatrick;rnd = mz[iz]*norm;//printf("  %f\n", rnd);
if(rnd<(double)(1/(exp((energy[i][j][k]-mu)*beta)+1))){
lat[i][j][k]=npar;lat1[i][j][k]=1;x[npar]=i;y[npar]=j;z[npar]=k;
//printf("Das i=%d Teilchen sitzt am Punkt [%d][%d][%d]\n",npar,x[npar],y[npar],z[npar]); 

npar++;}
}}}
printf("Die Anzahl der Teilchen: %d\n",npar);
hpar=jzmax/npar+1; 
}
/************************/
void MDS_determination(void)
{
const int hdir=jzmax/6+1;
double transprob;
int ranpar,randir,newx,newy,newz,oldx,oldy,oldz;
for(i=0; i<npar; i++){
distX[i]=0;  
distY[i]=0;
distZ[i]=0;
}
jump=0; 
for(ZeitInt=1;ZeitInt<Zeitmax;ZeitInt++){
for(i=0; i<npar; i++){
R[ZeitInt-1][i]=0.0;}}
ZeitInt=1;
Zeit=0;
while(Zeit<=Zeitmax){/*1*/
ZeitM=Zeit;
Kirkpatrick;
ranpar=mz[iz]/hpar; //printf(" ranpar ist %d\n", ranpar);
Kirkpatrick;
randir=mz[iz]/hdir;//printf(" randir ist %d\n", randir);
/********************************************/
newx=x[ranpar]+dirx[randir];
newy=y[ranpar]+diry[randir];
newz=z[ranpar]+dirz[randir];
if(newx==nlin) newx=0;
else if(newx==-1) newx=nlin-1;
else if((newx<nlin-1)&(newx>0)) newx=x[ranpar]+dirx[randir];
 if(newy==nlin) newy=0;
else if(newy==-1) newy=nlin-1;
else if((newy<nlin-1)&(newy>0)) newy=y[ranpar]+diry[randir];
if(newz==nlin) newz=0;
else if(newz==-1) newz=nlin-1;
else if((newz<nlin-1)&(newz>0)) newz=z[ranpar]+dirz[randir];


if(lat1[newx][newy][newz]==0){/*4*/
oldx=x[ranpar];oldy=y[ranpar];oldz=z[ranpar];
if(energy[oldx][oldy][oldz]>=energy[newx][newy][newz]){/*5a*/
jump+=1;
distX[ranpar]+=dirx[randir];
distY[ranpar]+=diry[randir];
distZ[ranpar]+=dirz[randir];
x[ranpar]=newx;y[ranpar]=newy;z[ranpar]=newz;
lat1[oldx][oldy][oldz]=0;lat1[newx][newy][newz]=1;/*5a*/
//printf("bei t= %f sitzt das Teilchen iA= %d am Punkt (%d,%d,%d)\n",Zeit,ranpar,x[ranpar],y[ranpar],z[ranpar]);
//printf("bei t= %f sitzt das Teilchen iA= %d am Punkt (%d,%d,%d)\n",Zeit,ranpar,distX[ranpar],distY[ranpar],distZ[ranpar]);
}
else{/*5b*/
Kirkpatrick;
transprob=jzmax*exp(-beta*(energy[newx][newy][newz]-energy[oldx][oldy][oldz]));
if(mz[iz]<transprob){/*6b*/
jump+=1;
distX[ranpar]+=dirx[randir];
distY[ranpar]+=diry[randir];
distZ[ranpar]+=dirz[randir];
x[ranpar]=newx;y[ranpar]=newy;z[ranpar]=newz;
lat1[oldx][oldy][oldz]=0;lat1[newx][newy][newz]=1;
//printf("bei t= %f sitzt das Teilchen iA= %d am Punkt (%d,%d,%d)\n",time,ranpar,z[ranpar],y[ranpar],x[ranpar]);
/*6b,5b*/}}
/*4*/}

Zeit+=1/double(npar);//printf("Der zeitschritt %f\n",Zeit);
if(ZeitM<ZeitInt && Zeit>=ZeitInt){
for(i=0;i<npar;i++){
R[ZeitInt-1][i]=((distX[i]*distX[i])+(distY[i]*distY[i])+(distZ[i]*distZ[i]))/double(npar);
}
for(i=0;i<npar;i++){
for(j=i+1;j<npar;j++){
Kreuzkorr[ZeitInt-1]+=R[ZeitInt-1][i]*R[ZeitInt-1][j]/double(npar);
}}
//printf("%d\t%f\n",ZeitInt-1,R[ZeitInt-1]);
ZeitInt+=1;
}
/*1*/}//Zeit
printf(" Die mittlere Sprungrate %15f\n",jump/double(npar*Zeitmax));

}

/*****************************************/
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x, c,beta,nlin);	// belegt Parameter
strcat(name_x, ".dat");			// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");

  
for(ZeitInt=2;ZeitInt <= 12; ZeitInt++){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),Kreuzkorr[ZeitInt-1]);
}
l=15;
for(ZeitInt=12;ZeitInt < Zeitmax; ZeitInt++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);
if(ZeitInt==t){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),Kreuzkorr[ZeitInt-1]);
l++;}}
fclose(outfile);
}
/*****************************************/
