#include<stdio.h>
#include <stdlib.h> 
#include <string.h> 
#include <math.h>

#define nlin 30
#define c   0.4
#define beta 14
#define E 0.1
#define Iconf 100
#define Zeitmax 500000
#define nphase 50000


#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];
#define outfile_x "Strom_3D_Energielandschaft_%f_%d_%d"
/************************/
int iz=1;
int mz[250];
int seed=372067;
int jzmax=2147483647,jz,a0=16807;
int np[500000];
double norm,rnd,mu;
/************************/
double energy[nlin][nlin][nlin];
int lat[nlin][nlin][nlin],lat1[nlin][nlin][nlin],iconf;
int npar,x_par[nlin*nlin*nlin],y_par[nlin*nlin*nlin],z_par[nlin*nlin*nlin];
int dirx[6]={-1,1,0,0,0,0};
int diry[6]={0,0,-1,1,0,0};
int dirz[6]={0,0,0,0,-1,1};
/************************/
void outputfile();
double current[Iconf][nphase+1],curfct[nphase+1],f;
int i,j,k,hpar;
/************************/
void rndNum(int seed)  
{
norm=1.0/jzmax;
int jz,jzmax=2147483647,a0=16807;
jz=2*seed+1;for(i=0;i < 250;i++){jz *= a0; if(jz < 0) jz += jzmax +1; mz[i] = jz;}
}
/************************/
int main() 
{
printf("beta=%d\t\n",beta);
printf("c=%f\t\n",c);
for(iconf=0;iconf<Iconf;++iconf){
printf("iconf=%d\t\n",iconf);
seed=seed+2*iconf;
rndNum(seed);
for(i=0;i<500000; i++){np[i]=0;}
/************************************************************************/     
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
Kirkpatrick;rnd = mz[iz]*norm;
energy[i][j][k]=rnd;
}}}
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){
lat[i][j][k]=0;lat1[i][j][k]=0;}}}
/************************/
mu=(1/(double)beta)*log((1-exp(-c*beta))/(exp(-1*c*beta)-exp(-1*beta)));
npar=0;
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                
for(k = 0;k<(nlin);k++){

Kirkpatrick;rnd = mz[iz]*norm;
if(rnd<(double)(1/(exp((energy[i][j][k]-mu)*beta)+1))){
lat[i][j][k]=npar;lat1[i][j][k]=1;x_par[npar]=k;y_par[npar]=j;z_par[npar]=i;
npar++;}
}}}
printf("Die Anzahl der Teilchen: %d\n",npar);
hpar=jzmax/npar+1; 
/**********************/

const int hdir=jzmax/6+1;
double transprob,time,phtime[nphase+1],deltasteps[nphase+1];
long xback,xfor;
int cur,ranpar,randir,deltax,newx,newy,newz,oldx,oldy,oldz,istep,iphase;
phtime[0]=0.0;
for(i=1;i<=nphase;i++){
phtime[i]=Zeitmax*i/(nphase);
deltasteps[i]=npar*(phtime[i]-phtime[i-1]);
//printf("%f\n",deltasteps[i]);
}
for(i=1;i<=nphase;i++) current[iconf][i]=0.0;
for(i=1;i<=nphase;i++){/*2*/
cur=0;
for(j=0;j<deltasteps[i];j++){/*3*/
time=phtime[i-1]+(double) j/npar;
Kirkpatrick;ranpar=mz[iz]/hpar;
f=E*beta; 
xback=jzmax*(1.0-f)/6.0;
xfor=jzmax*(1.0+f)/6.0;
Kirkpatrick;
if(mz[iz]<=xback) randir=0;
else if(mz[iz]<=xfor) randir=1;
else randir=mz[iz]/hdir;
/********************************************/
deltax=dirx[randir];
newx=x_par[ranpar]+dirx[randir];
newy=y_par[ranpar]+diry[randir];
newz=z_par[ranpar]+dirz[randir];
if(newx==nlin) newx=0;
else if(newx==-1) newx=nlin-1;
else if((newx<nlin-1)&(newx>0)) newx=x_par[ranpar]+dirx[randir];
if(newy==nlin) newy=0;
else if(newy==-1) newy=nlin-1;
else if((newy<nlin-1)&(newy>0)) newy=y_par[ranpar]+diry[randir];
if(newz==nlin) newz=0;
else if(newz==-1) newz=nlin-1;
else if((newz<nlin-1)&(newz>0)) newz=z_par[ranpar]+dirz[randir];
if((lat1[newx][newy][newz]==0)){/*4*/
oldx=x_par[ranpar];oldy=y_par[ranpar];oldz=z_par[ranpar];
if(energy[oldx][oldy][oldz]==energy[newx][newy][newz]){/*5a*/
cur+=deltax;
x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
lat1[oldx][oldy][oldz]=0;lat1[newx][newy][newz]=1;/*5a*/
}
else{/*5b*/
Kirkpatrick;
transprob=jzmax*exp(-beta*(energy[newx][newy][newz]));
if(mz[iz]<=transprob){/*6b*/
cur+=deltax;
x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
lat1[oldx][oldy][oldz]=0;lat1[newx][newy][newz]=1;
/*6b,5b*/}}
/*4*/}
/*****************************************/
/*3*/}
current[iconf][i]=current[iconf][i]+cur;
/*2*/}

for(i=1;i<=nphase;i++){
current[iconf][i]=current[iconf][i]/(double)((nlin*nlin*nlin)*(phtime[i]-phtime[i-1]));
}
/*****************************************/  
}



for(i=1;i<=nphase;i++){
for(iconf=0;iconf<Iconf;++iconf){
curfct[i]+=current[iconf][i]/Iconf;}
//printf(" %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
outputfile() ;        
return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x,c,beta,nlin);	
strcat(name_x, ".dat");// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");
for(i=1;i<12;i++){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
l=15;
for(i=12;i < nphase; i++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);

if(i==t){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
l++;}}
fclose(outfile);
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX







