#include<stdio.h>
#include <string.h> 
#include <math.h>




#define nlin 50
#define c   0.05     
#define beta 35
#define Zeitmax 10000000
#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];
#define outfile_x "MVQ11_%f_%d"
/************************/
int iz=1;
int mz[250];
const long seed=372067;
int jzmax=2147483647,jz,a0=16807;
int np[500000];
double norm,rnd,mu,rnd1,Minimum;
/************************/
double energy[nlin][nlin];
int    lat[nlin][nlin],lat1[nlin][nlin]
       ,distX[nlin*nlin],distY[nlin*nlin];
int    i,j,hpar,npar,x[nlin*nlin],y[nlin*nlin];
int    dirx[4]={-1,1,0,0};
int    diry[4]={0,0,-1,1};


/************************/
int jump,ZeitM, ZeitInt;
double Zeit,R[Zeitmax];
double t_rechts,t_links,t_above,t_down;
int xR,xL,yA,yD;
/************************/
void outputfile();
void rndNum(int seed);
void MDS_determination(void);
void initialize();
void readstruc ();
/************************/
void rndNum(int seed)  
{
norm=1.0/jzmax;
int jz,jzmax=2147483647,a0=16807;
jz=2*seed+1;for(i=0;i < 250;i++){jz *= a0; if(jz < 0) jz += jzmax +1; mz[i] = jz;}
}
/************************/
int main() 
{
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;
}
initialize ();
readstruc();
MDS_determination();
outputfile();
}
/************************/
void initialize () 
{
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                

Kirkpatrick;rnd = mz[iz]*norm;
energy[i][j]=rnd;//printf("energy[%d][%d] ist %f\n",i,j,energy[i][j]);
}}
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                

lat[i][j]=0;lat1[i][j]=0;}}
}
/************************/
void readstruc ()  
{
mu=(1/(double)beta)*log((1-exp(-c*beta))/(exp(-1*c*beta)-exp(-1*beta)));
printf(" mu ist %f\n",mu);
npar=0;
for(i = 0;i<(nlin);i++){  
for(j = 0;j<(nlin);j++){                                                                                

Kirkpatrick;rnd = mz[iz]*norm;//printf("  %f\n", rnd);
if(rnd<(double)(1/(exp((energy[i][j]-mu)*beta)+1))){
lat[i][j]=npar;lat1[i][j]=1;x[npar]=i;y[npar]=j;
//printf("Das i=%d Teilchen sitzt am Punkt [%d][%d]\n",npar,x[npar],y[npar]); 

npar++;}
}}
printf("Die Anzahl der Teilchen: %d\n",npar);
hpar=jzmax/npar+1; 
}
/************************/
void MDS_determination(void)
{
const int hdir=jzmax/6+1;
double transprob;
int ranpar,randir,oldx,oldy,newx,newy;
for(i=0; i<npar; i++){
distX[i]=0;  
distY[i]=0;

}
jump=0; 
for(ZeitInt=1;ZeitInt<Zeitmax;ZeitInt++){
R[ZeitInt-1]=0.0;}
ZeitInt=1;
Zeit=0;
while(Zeit<=Zeitmax){/*1*/
ZeitM=Zeit;
double Minimum,Minimum_x,Minimum_y;
int newx_x,newy_x;
int newx_y,newy_y;
int distX_x,distY_x;
int distX_y,distY_y;
Minimum=0.0;Minimum_x=0.0;Minimum_y=0.0;
t_rechts=0.0;t_links=0.0;t_above=0.0;t_down=0.0;
distX_x=0;distY_x=0;
distX_y=0;distY_y=0;
newx_x=0;newy_x=0;
newx_y=0;newy_y=0;
newx=0;newy=0;
Kirkpatrick;
ranpar=mz[iz]/hpar; //printf(" ranpar ist %d\n", ranpar);
/********************************************/
if(x[ranpar]==nlin-1)
{
xR=0;
}
else
{
xR=x[ranpar]+1;
}

if(x[ranpar]==0)
{
xL=nlin-1;
}
else
{
xL=x[ranpar]-1;
}
/*******************************/
if(y[ranpar]==nlin-1)
{
yA=0;
}
else
{
yA=y[ranpar]+1;
}

if(y[ranpar]==0)
{
yD=nlin-1;
}
else
{
yD=y[ranpar]-1;
}

/*******************************/
if(lat1[xR][y[ranpar]]==0){/*Recht*/
oldx=x[ranpar];oldy=y[ranpar];
if(energy[oldx][oldy]>=energy[xR][oldy])

{/*5a*/

Kirkpatrick;rnd = mz[iz]*norm;
t_rechts=(-log(rnd));
//printf("t_rechts %f\n",t_rechts);

/*5a*/}

else if(energy[oldx][oldy]<energy[xR][oldy])

{/*5b*/
Kirkpatrick;rnd = mz[iz]*norm;
transprob=exp(-beta*(energy[xR][oldy]-energy[oldx][oldy]));
if(rnd<transprob){/*6b*/

Kirkpatrick;rnd1 = mz[iz]*norm;
t_rechts=(-log(rnd1))/(transprob);
//printf("t_rechts %f\n",t_rechts);
/*6b,5b*/}}

else
{
t_rechts=0.0;
}

/*Rechts*/}
/*********************************/
if(lat1[xL][y[ranpar]]==0){/*Links*/
oldx=x[ranpar];oldy=y[ranpar];
if(energy[oldx][oldy]>=energy[xL][oldy])

{/*5a*/

Kirkpatrick;rnd = mz[iz]*norm;
t_links=(-log(rnd));
//printf("t_links %f\n",t_links);

/*5a*/}

else if(energy[oldx][oldy]<energy[xL][oldy])

{/*5b*/
Kirkpatrick;rnd = mz[iz]*norm;
transprob=exp(-beta*(energy[xL][oldy]-energy[oldx][oldy]));
if(rnd<transprob){/*6b*/

Kirkpatrick;rnd1 = mz[iz]*norm;
t_links=(-log(rnd1))/(transprob);
//printf("t_links %f\n",t_links);
/*6b,5b*/}}
else
{
t_links=0.0;
}

/*Links*/}
/*********************************/
if(lat1[x[ranpar]][yA]==0){/*Above*/
oldx=x[ranpar];oldy=y[ranpar];
if(energy[oldx][oldy]>=energy[oldx][yA])

{/*5a*/

Kirkpatrick;rnd = mz[iz]*norm;
t_above=(-log(rnd));
//printf("t_above %f\n",t_above);

/*5a*/}

else if(energy[oldx][oldy]<energy[oldx][yA])
{/*5b*/
Kirkpatrick;rnd = mz[iz]*norm;
transprob=exp(-beta*(energy[oldx][yA]-energy[oldx][oldy]));
if(rnd<transprob){/*6b*/

Kirkpatrick;rnd1 = mz[iz]*norm;
t_above=(-log(rnd1))/(transprob);
//printf("t_above %f\n",t_above);
/*6b,5b*/}}
else
{
t_above=0.0;
}

/*Above*/}
/*********************************/
if(lat1[x[ranpar]][yD]==0){/*Down*/
oldx=x[ranpar];oldy=y[ranpar];
if(energy[oldx][oldy]>=energy[oldx][yD])

{/*5a*/

Kirkpatrick;rnd = mz[iz]*norm;
t_down=(-log(rnd));
//printf("t_down %f\n",t_down);

/*5a*/}

else if(energy[oldx][oldy]<energy[oldx][yD])
{/*5b*/
Kirkpatrick;rnd = mz[iz]*norm;
transprob=exp(-beta*(energy[oldx][yD]-energy[oldx][oldy]));
if(rnd<transprob){/*6b*/

Kirkpatrick;rnd1 = mz[iz]*norm;
t_down=(-log(rnd1))/(transprob);
//printf("t_down %f\n",t_down);


/*6b,5b*/}}
else
{
t_down=0.0;
}

/*Down*/}
/*********************************/
if((t_rechts!=0)&&(t_links==0))
{
Minimum_x=t_rechts;
newx_x=xR;
newy_x=y[ranpar];

}
else if((t_rechts==0)&&(t_links!=0))
{
Minimum_x=t_links;
newx_x=xL;
newy_x=y[ranpar];

}
else if(t_rechts<t_links)
{
Minimum_x=t_rechts;
newx_x=xR;
newy_x=y[ranpar];

}
else if(t_rechts>t_links)
{
Minimum_x=t_links;
newx_x=xL;
newy_x=y[ranpar];

}
//printf("Minimum_x %f\n",Minimum_x);
/****************************/
if((t_above!=0)&&(t_down==0))
{
Minimum_y=t_above;
newx_y=x[ranpar];
newy_y=yA;

}
else if((t_above==0)&&(t_down!=0))
{
Minimum_y=t_down;
newx_y=x[ranpar];
newy_y=yD;

}
else if(t_above<t_down)
{
Minimum_y=t_above;
newx_y=x[ranpar];
newy_y=yA;

}
else if(t_above>t_down)
{
Minimum_y=t_down;
newx_y=x[ranpar];
newy_y=yD;

}
//printf("Minimum_y %f\n",Minimum_y);
/***************************/
if((Minimum_y==0)&&(Minimum_x==0))
{
Minimum=Minimum_y;
newx=x[ranpar];
newy=y[ranpar];



}
if((Minimum_y!=0)&&(Minimum_x==0))
{
Minimum=Minimum_y;
newx=newx_y;
newy=newy_y;



}

else if((Minimum_y==0)&&(Minimum_x!=0))
{
Minimum=Minimum_x;
newx=newx_x;
newy=newy_x;



}

else if(Minimum_y<Minimum_x)
{
Minimum=Minimum_y;
newx=newx_y;
newy=newy_y;



}
else if(Minimum_y>Minimum_x)
{
Minimum=Minimum_x;
newx=newx_x;
newy=newy_x;

}
//printf("Minimum %f\n",Minimum);

if((x[ranpar]==nlin-1)&&(newx==0))
{
distX[ranpar]+=1;
}
else if((x[ranpar]==0)&&(newx==nlin-1))
{
distX[ranpar]-=1;
}
else 
{
distX[ranpar]+=newx-x[ranpar];
}
if((y[ranpar]==nlin-1)&&(newy==0))
{
distY[ranpar]+=1;
}
else if((y[ranpar]==0)&&(newy==nlin-1))
{
distY[ranpar]-=1;
}
else 
{
distY[ranpar]+=newy-y[ranpar];
}


x[ranpar]=newx;y[ranpar]=newy;jump+=1;
lat1[oldx][oldy]=0;lat1[newx][newy]=1;


Zeit+=1/double(npar);/*5a*/
//printf("bei t= %f sitzt das Teilchen iA= %d am Punkt (%d,%d)\n",Zeit,ranpar,x[ranpar],y[ranpar]);
//printf("bei t= %f sitzt das Teilchen iA= %d am Punkt (%d,%d)\n",Zeit,ranpar,distX[ranpar],distY[ranpar]);




if(ZeitM<ZeitInt && Zeit>=ZeitInt){
for(i=0;i<npar;i++){

R[ZeitInt-1]+=((distX[i]*distX[i])+(distY[i]*distY[i]))/double(npar);

}

//printf("%d\t%f\n",ZeitInt-1,R[ZeitInt-1]);
ZeitInt+=1;
}
/*1*/}//Zeit
printf(" Die mittlere Sprungrate %15f\n",jump/double(npar*Zeitmax));

}

/*****************************************/
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x, c,beta,nlin);	// belegt Parameter
strcat(name_x, ".dat");			// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");

  
for(ZeitInt=1;ZeitInt <= 12; ZeitInt++){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),R[ZeitInt-1]);
}
l=15;
for(ZeitInt=12;ZeitInt < Zeitmax; ZeitInt++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);
if(ZeitInt==t){
fprintf(outfile,"%15f  %15f\n ",double(ZeitInt),R[ZeitInt-1]);
l++;}}
fclose(outfile);
}
/*****************************************/
