# NOTE: This script can be modified for different pair styles 
# See in.elastic for more info.

reset_timestep 0

# Choose potential
pair_style      born/coul/long 10

pair_coeff 1 1 0.16779911104   0.16922   2.161  0.0   0.0
pair_coeff 1 2 0.11647372405    0.11746  1.9493  0.0  0.0
pair_coeff 1 3 0.25808459184  0.26027  3.1279  0.0  0.0
pair_coeff 2 2 0.06514833705 0.0657   1.7376    532.80075093   0.0
pair_coeff 2 3 0.20675920484  0.20851   2.9162    1613.29335793  0.0
pair_coeff 3 3 0.34837076445   0.35132   4.0948   4910.3569895  0.0

kspace_style	ewald 1e-6

# Setup neighbor style
neighbor 1.0 nsq
neigh_modify once no every 1 delay 0 check yes

# Setup output

fix avp all ave/time  ${nevery} ${nrepeat} ${nfreq} c_thermo_press mode vector
thermo		${nthermo}
thermo_style custom step temp pe press f_avp[1] f_avp[2] f_avp[3] f_avp[4] f_avp[5] f_avp[6]
thermo_modify norm no

# Setup MD

timestep ${timestep}
fix 4 all nve
if "${thermostat} == 1" then &
   "fix 5 all langevin ${temp} ${temp} ${tdamp} ${seed}"


